function V = gauss_seidel(Bus_Data,Branch_Data)

%% Inicijalizacija

ID = Bus_Data(:,1) ; 
Bus_Type = Bus_Data(:,2) ; 
P_load = Bus_Data(:,3) ; 
Q_load = Bus_Data(:,4) ; 
P_gen = Bus_Data(:,5) ; 
Q_gen = Bus_Data(:,6) ;
P = P_gen - P_load ;
Q = Q_gen - Q_load ; 
V = Bus_Data(:,7) ;
V_specified = V ; 
Theta = Bus_Data(:,8) ;

% Formiranje matrice Yb

Yb = create_Yb(Bus_Data,Branch_Data) ;

% Odredjivanje tipa cvora

Number_of_Buses = length(ID) ; 
PQ_Buses = find(Bus_Type==3) ;
Number_of_PQ_Buses = length(PQ_Buses) ; 
PV_Buses = find(Bus_Type==2) ;
Number_of_PV_Buses = length(PV_Buses) ; 
Slack_Bus = find(Bus_Type==1) ; 

% Inicijalizacija promjenljivih za glavnu petlju

V = V.*exp(sqrt(-1)*Theta) ; 
V_old = 0*V ; 
Tolerance = 1e-3 ;
Iteration = 0 ;

%% Glavna petlja

while max(abs(V-V_old)) > Tolerance
    
    V_old = V ;
    Iteration = Iteration + 1 ;
    
    for i = 2 : Number_of_Buses
        
        if Bus_Type(i) == 2
            
            S = 0 ;
            
            for j = 1 : Number_of_Buses
                
               S = S + Yb(i,j)*V(j) ; 
                
            end
            
            Q(i) = -imag(conj(V(i))*S) ;
            
        end
        
        % Update napona
        
        S = 0 ;
        
        for j = 1 : Number_of_Buses
            
            if i ~= j
            
                S = S + Yb(i,j)*V(j) ;
            
            end
            
        end
        
        V(i) = 1/Yb(i,i)*((P(i)-sqrt(-1)*Q(i))/conj(V(i))-S) ; 
        
        if Bus_Type(i) == 2
           
            Phase_Angle = angle(V(i)) ; 
            V(i) = abs(V_old(i))*exp(sqrt(-1)*Phase_Angle) ; 
            
        end
           
    end
    
end

end